package orderservicelogic

// func TestConvertOrdersToGetOrderResp(t *testing.T) {
// 	tests := []struct {
// 		name     string
// 		input    []model.Order
// 		expected []*order.GetOrderResp
// 	}{
// 		{
// 			name:     "空訂單列表",
// 			input:    []model.Order{},
// 			expected: []*order.GetOrderResp{},
// 		},
// 		{
// 			name: "單筆訂單",
// 			input: []model.Order{
// 				{
// 					BusinessID:  "B123",
// 					OrderType:   1,
// 					OrderStatus: 2,
// 					Brand:       "TestBrand",
// 					OrderUID:    "UID123",
// 					ReferenceID: "REF123",
// 					Count:       decimal.RequireFromString("10.5"),
// 					OrderFee:    decimal.RequireFromString("0.5"),
// 					Amount:      decimal.RequireFromString("100"),
// 				},
// 			},
// 			expected: []*order.GetOrderResp{
// 				{
// 					BusinessId:  "B123",
// 					OrderType:   1,
// 					OrderStatus: 2,
// 					Brand:       "TestBrand",
// 					OrderUid:    "UID123",
// 					ReferenceId: "REF123",
// 					Count:       "10.5",
// 					OrderFee:    "0.5",
// 					Amount:      "100",
// 				},
// 			},
// 		},
// 		{
// 			name: "多筆訂單",
// 			input: []model.Order{
// 				{
// 					BusinessID:  "B123",
// 					OrderType:   1,
// 					OrderStatus: 2,
// 					Brand:       "TestBrand",
// 					OrderUID:    "UID123",
// 					ReferenceID: "REF123",
// 					Count:       decimal.RequireFromString("10.5"),
// 					OrderFee:    decimal.RequireFromString("0.5"),
// 					Amount:      decimal.RequireFromString("100"),
// 				},
// 				{
// 					BusinessID:  "B456",
// 					OrderType:   2,
// 					OrderStatus: 3,
// 					Brand:       "OtherBrand",
// 					OrderUID:    "UID456",
// 					ReferenceID: "REF456",
// 					Count:       decimal.RequireFromString("20"),
// 					OrderFee:    decimal.RequireFromString("1"),
// 					Amount:      decimal.RequireFromString("200"),
// 				},
// 			},
// 			expected: []*order.GetOrderResp{
// 				{
// 					BusinessId:  "B123",
// 					OrderType:   1,
// 					OrderStatus: 2,
// 					Brand:       "TestBrand",
// 					OrderUid:    "UID123",
// 					ReferenceId: "REF123",
// 					Count:       "10.5",
// 					OrderFee:    "0.5",
// 					Amount:      "100",
// 				},
// 				{
// 					BusinessId:  "B456",
// 					OrderType:   2,
// 					OrderStatus: 3,
// 					Brand:       "OtherBrand",
// 					OrderUid:    "UID456",
// 					ReferenceId: "REF456",
// 					Count:       "20",
// 					OrderFee:    "1",
// 					Amount:      "200",
// 				},
// 			},
// 		},
// 	}
//
// 	for _, tt := range tests {
// 		t.Run(tt.name, func(t *testing.T) {
// 			// 執行 ConvertOrdersToGetOrderResp 函數
// 			result := ConvertOrdersToGetOrderResp(tt.input)
//
// 			// 驗證結果
// 			assert.Equal(t, tt.expected, result)
// 		})
// 	}
// }
//
// func TestOptionalString(t *testing.T) {
// 	t.Run("非 nil 字串", func(t *testing.T) {
// 		str := "hello"
// 		result := optionalString(&str)
// 		assert.NotNil(t, result)
// 		assert.Equal(t, &str, result)
// 	})
//
// 	t.Run("nil 字串", func(t *testing.T) {
// 		result := optionalString(nil)
// 		assert.Nil(t, result)
// 	})
// }
//
// func TestOptionalInt64(t *testing.T) {
// 	t.Run("非 nil int64", func(t *testing.T) {
// 		num := int64(123)
// 		result := optionalInt64(&num)
// 		assert.NotNil(t, result)
// 		assert.Equal(t, &num, result)
// 	})
//
// 	t.Run("nil int64", func(t *testing.T) {
// 		result := optionalInt64(nil)
// 		assert.Nil(t, result)
// 	})
// }
//
// func TestOptionalDecimalToString(t *testing.T) {
// 	t.Run("非 nil decimal", func(t *testing.T) {
// 		dec := decimal.NewFromInt(123)
// 		expected := "123"
// 		result := optionalDecimalToString(&dec)
// 		assert.NotNil(t, result)
// 		assert.Equal(t, &expected, result)
// 	})
//
// 	t.Run("nil decimal", func(t *testing.T) {
// 		result := optionalDecimalToString(nil)
// 		assert.Nil(t, result)
// 	})
// }
//
// func TestConvertOrderToGetOrderResp(t *testing.T) {
// 	tests := []struct {
// 		name     string
// 		input    model.Order
// 		expected *order.GetOrderResp
// 	}{
// 		{
// 			name: "所有欄位都有值",
// 			input: model.Order{
// 				BusinessID:           "B123",
// 				OrderType:            1,
// 				OrderStatus:          2,
// 				Brand:                "TestBrand",
// 				OrderUID:             "UID123",
// 				ReferenceID:          "REF123",
// 				Count:                decimal.RequireFromString("10.5"),
// 				OrderFee:             decimal.RequireFromString("0.5"),
// 				Amount:               decimal.RequireFromString("100"),
// 				ReferenceBrand:       ptrString("OtherBrand"),
// 				ReferenceUID:         ptrString("REFUID"),
// 				WalletStatus:         ptrInt64(1),
// 				ThreePartyStatus:     ptrInt64(2),
// 				DirectionType:        ptrInt64(1),
// 				CryptoType:           ptrString("BTC"),
// 				ThirdPartyFee:        decimalPtrFromString("0.01"),
// 				CryptoToUSDTRate:     decimalPtrFromString("50000"),
// 				FiatToUSDRate:        decimalPtrFromString("1"),
// 				FeeCryptoToUSDTRate:  decimalPtrFromString("0.02"),
// 				USDTToCryptoTypeRate: decimalPtrFromString("0.00002"),
// 				PaymentFiat:          ptrString("USD"),
// 				PaymentUnitPrice:     decimalPtrFromString("50000"),
// 				PaymentTemplateID:    ptrString("TEMPLATE123"),
// 				OrderArrivalTime:     ptrInt64(1630000000),
// 				OrderPaymentTime:     ptrInt64(1620000000),
// 				UnpaidTimeoutSecond:  ptrInt64(3600),
// 				ChainType:            ptrString("ETH"),
// 				TxHash:               ptrString("0xABC123"),
// 				FromAddress:          ptrString("0xFROM123"),
// 				ToAddress:            ptrString("0xTO123"),
// 				ChainFee:             decimalPtrFromString("0.001"),
// 				ChainFeeCrypto:       ptrString("ETH"),
// 				Memo:                 ptrString("Test Memo"),
// 				OrderNote:            ptrString("Test Note"),
// 				CreateTime:           1620000000,
// 				UpdateTime:           1630000000,
// 			},
// 			expected: &order.GetOrderResp{
// 				BusinessId:           "B123",
// 				OrderType:            1,
// 				OrderStatus:          2,
// 				Brand:                "TestBrand",
// 				OrderUid:             "UID123",
// 				ReferenceId:          "REF123",
// 				Count:                "10.5",
// 				OrderFee:             "0.5",
// 				Amount:               "100",
// 				ReferenceBrand:       ptrString("OtherBrand"),
// 				ReferenceUid:         ptrString("REFUID"),
// 				WalletStatus:         ptrInt64(1),
// 				ThreePartyStatus:     ptrInt64(2),
// 				DirectionType:        ptrInt64(1),
// 				CryptoType:           ptrString("BTC"),
// 				ThirdPartyFee:        ptrString("0.01"),
// 				CryptoToUsdtRate:     ptrString("50000"),
// 				FiatToUsdRate:        ptrString("1"),
// 				FeeCryptoToUsdtRate:  ptrString("0.02"),
// 				UsdtToCryptoTypeRate: ptrString("0.00002"),
// 				PaymentFiat:          ptrString("USD"),
// 				PaymentUnitPrice:     ptrString("50000"),
// 				PaymentTemplateId:    ptrString("TEMPLATE123"),
// 				OrderArrivalTime:     ptrInt64(1630000000),
// 				OrderPaymentTime:     ptrInt64(1620000000),
// 				UnpaidTimeoutSecond:  ptrInt64(3600),
// 				ChainType:            ptrString("ETH"),
// 				TxHash:               ptrString("0xABC123"),
// 				FromAddress:          ptrString("0xFROM123"),
// 				ToAddress:            ptrString("0xTO123"),
// 				ChainFee:             ptrString("0.001"),
// 				ChainFeeCrypto:       ptrString("ETH"),
// 				Memo:                 ptrString("Test Memo"),
// 				OrderNote:            ptrString("Test Note"),
// 				CreateTime:           1620000000,
// 				UpdateTime:           1630000000,
// 			},
// 		},
// 		{
// 			name: "部分欄位為 nil",
// 			input: model.Order{
// 				BusinessID:           "B456",
// 				OrderType:            1,
// 				OrderStatus:          2,
// 				Brand:                "TestBrand",
// 				OrderUID:             "UID456",
// 				ReferenceID:          "REF456",
// 				Count:                decimal.RequireFromString("10"),
// 				OrderFee:             decimal.RequireFromString("1"),
// 				Amount:               decimal.RequireFromString("100"),
// 				ReferenceBrand:       nil,
// 				ReferenceUID:         nil,
// 				WalletStatus:         nil,
// 				ThreePartyStatus:     nil,
// 				DirectionType:        nil,
// 				CryptoType:           nil,
// 				ThirdPartyFee:        nil,
// 				CryptoToUSDTRate:     nil,
// 				FiatToUSDRate:        nil,
// 				FeeCryptoToUSDTRate:  nil,
// 				USDTToCryptoTypeRate: nil,
// 				PaymentFiat:          nil,
// 				PaymentUnitPrice:     nil,
// 				PaymentTemplateID:    nil,
// 				OrderArrivalTime:     nil,
// 				OrderPaymentTime:     nil,
// 				UnpaidTimeoutSecond:  nil,
// 				ChainType:            nil,
// 				TxHash:               nil,
// 				FromAddress:          nil,
// 				ToAddress:            nil,
// 				ChainFee:             nil,
// 				ChainFeeCrypto:       nil,
// 				Memo:                 nil,
// 				OrderNote:            nil,
// 				CreateTime:           1620000000,
// 				UpdateTime:           1630000000,
// 			},
// 			expected: &order.GetOrderResp{
// 				BusinessId:           "B456",
// 				OrderType:            1,
// 				OrderStatus:          2,
// 				Brand:                "TestBrand",
// 				OrderUid:             "UID456",
// 				ReferenceId:          "REF456",
// 				Count:                "10",
// 				OrderFee:             "1",
// 				Amount:               "100",
// 				ReferenceBrand:       nil,
// 				ReferenceUid:         nil,
// 				WalletStatus:         nil,
// 				ThreePartyStatus:     nil,
// 				DirectionType:        nil,
// 				CryptoType:           nil,
// 				ThirdPartyFee:        nil,
// 				CryptoToUsdtRate:     nil,
// 				FiatToUsdRate:        nil,
// 				FeeCryptoToUsdtRate:  nil,
// 				UsdtToCryptoTypeRate: nil,
// 				PaymentFiat:          nil,
// 				PaymentUnitPrice:     nil,
// 				PaymentTemplateId:    nil,
// 				OrderArrivalTime:     nil,
// 				OrderPaymentTime:     nil,
// 				UnpaidTimeoutSecond:  nil,
// 				ChainType:            nil,
// 				TxHash:               nil,
// 				FromAddress:          nil,
// 				ToAddress:            nil,
// 				ChainFee:             nil,
// 				ChainFeeCrypto:       nil,
// 				Memo:                 nil,
// 				OrderNote:            nil,
// 				CreateTime:           1620000000,
// 				UpdateTime:           1630000000,
// 			},
// 		},
// 	}
//
// 	for _, tt := range tests {
// 		t.Run(tt.name, func(t *testing.T) {
// 			// 執行 ConvertOrderToGetOrderResp 函數
// 			result := ConvertOrderToGetOrderResp(tt.input)
//
// 			// 驗證結果
// 			assert.Equal(t, tt.expected, result)
// 		})
// 	}
// }
//
// func TestListOrder(t *testing.T) {
// 	ctrl := gomock.NewController(t)
// 	defer ctrl.Finish()
//
// 	// 初始化 mock 依賴
// 	mockOrderModel := mockmodel.NewMockOrderModel(ctrl)
// 	mockValidate := mocksvc.NewMockValidate(ctrl)
//
// 	// 初始化服務上下文
// 	svcCtx := &svc.ServiceContext{
// 		OrderModel: mockOrderModel,
// 		Validate:   mockValidate,
// 	}
//
// 	// 測試數據集
// 	tests := []struct {
// 		name        string
// 		input       *order.ListOrderReq
// 		prepare     func()
// 		expectErr   bool
// 		expectedRes *order.ListOrderResp
// 	}{
// 		{
// 			name: "成功取得訂單列表",
// 			input: &order.ListOrderReq{
// 				PageIndex: 1,
// 				PageSize:  10,
// 			},
// 			prepare: func() {
// 				// 模擬驗證成功
// 				mockValidate.EXPECT().ValidateAll(gomock.Any()).Return(nil).Times(1)
// 				// 模擬返回訂單列表
// 				mockOrderModel.EXPECT().ListOrder(gomock.Any(), gomock.Any()).Return([]model.Order{
// 					{
// 						BusinessID:  "B123",
// 						OrderType:   1,
// 						OrderStatus: 2,
// 						Brand:       "TestBrand",
// 						OrderUID:    "UID123",
// 						ReferenceID: "REF123",
// 						Count:       decimal.RequireFromString("10.5"),
// 						OrderFee:    decimal.RequireFromString("0.5"),
// 						Amount:      decimal.RequireFromString("100"),
// 					},
// 				}, int64(1), nil).Times(1)
// 			},
// 			expectErr: false,
// 			expectedRes: &order.ListOrderResp{
// 				Data: []*order.GetOrderResp{
// 					{
// 						BusinessId:  "B123",
// 						OrderType:   1,
// 						OrderStatus: 2,
// 						Brand:       "TestBrand",
// 						OrderUid:    "UID123",
// 						ReferenceId: "REF123",
// 						Count:       "10.5",
// 						OrderFee:    "0.5",
// 						Amount:      "100",
// 					},
// 				},
// 				Page: &order.Pager{
// 					Total: 1,
// 					Index: 1,
// 					Size:  10,
// 				},
// 			},
// 		},
// 		{
// 			name: "訂單查詢失敗",
// 			input: &order.ListOrderReq{
// 				PageIndex: 1,
// 				PageSize:  10,
// 			},
// 			prepare: func() {
// 				// 模擬驗證成功
// 				mockValidate.EXPECT().ValidateAll(gomock.Any()).Return(nil).Times(1)
// 				// 模擬返回查詢錯誤
// 				mockOrderModel.EXPECT().ListOrder(gomock.Any(), gomock.Any()).Return(nil, int64(0), errors.New("query failed")).Times(1)
// 			},
// 			expectErr: true,
// 		},
// 		{
// 			name: "分頁錯誤",
// 			input: &order.ListOrderReq{
// 				PageIndex: 0,
// 				PageSize:  10,
// 			},
// 			prepare: func() {
// 				// 模擬驗證失敗，因為 PageIndex 為 0
// 				mockValidate.EXPECT().ValidateAll(gomock.Any()).Return(errors.New("invalid pagination")).Times(1)
// 			},
// 			expectErr: true,
// 		},
// 	}
//
// 	for _, tt := range tests {
// 		t.Run(tt.name, func(t *testing.T) {
// 			// 準備測試環境
// 			tt.prepare()
//
// 			// 初始化 ListOrderLogic
// 			logic := NewListOrderLogic(context.TODO(), svcCtx)
//
// 			// 執行 ListOrder
// 			resp, err := logic.ListOrder(tt.input)
//
// 			// 驗證結果
// 			if tt.expectErr {
// 				assert.Error(t, err)
// 				assert.Nil(t, resp)
// 			} else {
// 				assert.NoError(t, err)
// 				assert.Equal(t, tt.expectedRes, resp)
// 			}
// 		})
// 	}
// }
